Index: program/js/XMLHttpRequest.js
===================================================================
--- program/js/XMLHttpRequest.js	(revision 0)
+++ program/js/XMLHttpRequest.js	(revision 0)
@@ -0,0 +1,139 @@
+
+/**
+ * Class for sending HTTP requests
+ * @constructor
+ */
+function rcube_http_request()
+  {
+  this.url = '';
+  this.busy = false;
+  this.xmlhttp = null;
+
+
+  // reset object properties
+  this.reset = function()
+    {
+    // set unassigned event handlers
+    this.onloading = function(){ };
+    this.onloaded = function(){ };
+    this.oninteractive = function(){ };
+    this.oncomplete = function(){ };
+    this.onabort = function(){ };
+    this.onerror = function(){ };
+    
+    this.url = '';
+    this.busy = false;
+    this.xmlhttp = null;
+    }
+
+
+  // create HTMLHTTP object
+  this.build = function()
+    {
+    if (window.XMLHttpRequest)
+      this.xmlhttp = new XMLHttpRequest();
+    else if (window.ActiveXObject)
+      this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
+    else
+      {
+      
+      }
+    }
+
+  // send GET request
+  this.GET = function(url)
+    {
+    this.build();
+
+    if (!this.xmlhttp)
+      {
+      this.onerror(this);
+      return false;
+      }
+
+    var ref = this;
+    this.url = url;
+    this.busy = true;
+
+    this.xmlhttp.onreadystatechange = function(){ ref.xmlhttp_onreadystatechange(); };
+    this.xmlhttp.open('GET', url);
+    this.xmlhttp.send(null);
+    };
+
+
+  this.POST = function(url, body, contentType)
+    {
+    // default value for contentType if not provided
+    contentType = typeof(contentType) != 'undefined' ?
+      contentType : 'application/x-www-form-urlencoded';
+
+    this.build();
+    
+    if (!this.xmlhttp)
+    {
+       this.onerror(this);
+       return false;
+    }
+
+    var ref=this;
+    this.url = url;
+    this.busy = true;
+    
+    this.xmlhttp.onreadystatechange = function() { ref.xmlhttp_onreadystatechange(); };
+    this.xmlhttp.open('POST', url, true);
+    this.xmlhttp.setRequestHeader('Content-Type', contentType);
+    this.xmlhttp.send(body);
+    };
+
+
+  // handle onreadystatechange event
+  this.xmlhttp_onreadystatechange = function()
+    {
+    if(this.xmlhttp.readyState == 1)
+      this.onloading(this);
+
+    else if(this.xmlhttp.readyState == 2)
+      this.onloaded(this);
+
+    else if(this.xmlhttp.readyState == 3)
+      this.oninteractive(this);
+
+    else if(this.xmlhttp.readyState == 4)
+      {
+      try {
+        if (this.xmlhttp.status == 0)
+          this.onabort(this);
+        else if(this.xmlhttp.status == 200)
+          this.oncomplete(this);
+        else
+          this.onerror(this);
+
+        this.busy = false;
+        }
+      catch(err)
+        {
+        this.onerror(this);
+        this.busy = false;
+        }
+      }
+    }
+
+  // getter method for HTTP headers
+  this.get_header = function(name)
+    {
+    return this.xmlhttp.getResponseHeader(name);
+    };
+
+  this.get_text = function()
+    {
+    return this.xmlhttp.responseText;
+    };
+
+  this.get_xml = function()
+    {
+    return this.xmlhttp.responseXML;
+    };
+
+  this.reset();
+  
+  }  // end class rcube_http_request
Index: program/localization/en_GB/labels.inc
===================================================================
--- program/localization/en_GB/labels.inc	(revision 360)
+++ program/localization/en_GB/labels.inc	(working copy)
@@ -139,9 +139,47 @@
 // address boook
 $labels['name']      = 'Display name';
 $labels['firstname'] = 'First name';
-$labels['surname']   = 'Last name';
+$labels['lastname']   = 'Last name';
 $labels['email']     = 'E-Mail';
 
+$labels['middlename']       = 'Middle name'; 
+$labels['maidenname']       = 'Maiden name'; 
+$labels['prefix']           = 'Prefix'; 
+$labels['suffix']           = 'Suffix'; 
+$labels['gender']           = 'Gender'; 
+$labels['phone_home']       = 'Phone home'; 
+$labels['phone_pager']      = 'Phone pager'; 
+$labels['phone_mobile']     = 'Phone mobile'; 
+$labels['phone_work']       = 'Phone work'; 
+$labels['phone_fax']        = 'Phone fax'; 
+$labels['phone_other']      = 'Phone other'; 
+$labels['company_name']     = 'Company name';
+$labels['company_title']    = 'Company title'; 
+$labels['company_street']   = 'Company street'; 
+$labels['company_city']     = 'Company city';
+$labels['company_state']    = 'Company state'; 
+$labels['company_zip']      = 'Company zip'; 
+$labels['company_country']  = 'Company country'; 
+$labels['company_website']  = 'Company website'; 
+$labels['personal_street']  = 'personal street'; 
+$labels['personal_city']    = 'personal city'; 
+$labels['personal_state']   = 'personal state'; 
+$labels['personal_zip']     = 'personal zip'; 
+$labels['personal_country'] = 'personal country'; 
+$labels['personal_website'] = 'Personal website'; 
+$labels['str_birthday']     = 'Birthday'; 
+$labels['str_deathday']     = 'Deathday'; 
+$labels['str_anniversary']  = 'Anniversary'; 
+$labels['email1']           = 'Email 1'; 
+$labels['email2']           = 'Email 2'; 
+$labels['comments']         = 'Comments'; 
+$labels['image']            = 'Image';
+
+$labels['duplicates title'] = 'Duplicate entries';
+$labels['addgroup']     = 'Add group';
+$labels['removegroup']  = 'Remove group';
+$labels['editgroup']    = 'Edit group';
+
 $labels['addcontact'] = 'Add new contact';
 $labels['editcontact'] = 'Edit contact';
 
@@ -157,6 +195,14 @@
 $labels['print']          = 'Print';
 $labels['export']         = 'Export';
 
+// vCard
+$labels['uploadvcard']    = 'Import a vCard';
+
+// groupbox names
+$labels['grouplist']  = 'Group';
+$labels['all']  = 'All';
+$labels['last_imported'] = 'Last Imported';
+
 // LDAP search
 $labels['ldapsearch'] = 'LDAP directory search';
 
Index: program/localization/en_GB/messages.inc
===================================================================
--- program/localization/en_GB/messages.inc	(revision 360)
+++ program/localization/en_GB/messages.inc	(working copy)
@@ -102,5 +102,15 @@
 
 $messages['folderdeleted'] = 'Folder successfully deleted';
 
+$messages['vcard_instructions'] = 'Choose your vCard to upload<br/ >These will have the file suffix of .vcf';
 
+$messages['duplicate_entries'] = 'We found some entries already in your contact box these following contact shave not been added';
+
+$messages['duplicate_contact'] = 'One or more of your contacts already exists';
+
+$messages['deletecontactgroupconfirm']  = 'Do you really want to remove the selected contact(s) from this group?';
+
+$messages['deletegroupfolderconfirm']  = 'Do you really want to remove the selected group?';
+
+$messages['contactsearchsuccessful'] = '$nr contacts found';
 ?>
Index: program/localization/en_US/labels.inc
===================================================================
--- program/localization/en_US/labels.inc	(revision 360)
+++ program/localization/en_US/labels.inc	(working copy)
@@ -152,9 +152,47 @@
 // address boook
 $labels['name']      = 'Display name';
 $labels['firstname'] = 'First name';
-$labels['surname']   = 'Last name';
+$labels['lastname']   = 'Last name';
 $labels['email']     = 'E-Mail';
 
+$labels['middlename']       = 'Middle name'; 
+$labels['maidenname']       = 'Maiden name'; 
+$labels['prefix']           = 'Prefix'; 
+$labels['suffix']           = 'Suffix'; 
+$labels['gender']           = 'Gender'; 
+$labels['phone_home']       = 'Phone home'; 
+$labels['phone_pager']      = 'Phone pager'; 
+$labels['phone_mobile']     = 'Phone mobile'; 
+$labels['phone_work']       = 'Phone work'; 
+$labels['phone_fax']        = 'Phone fax'; 
+$labels['phone_other']      = 'Phone other'; 
+$labels['company_name']     = 'Company name';
+$labels['company_title']    = 'Company title'; 
+$labels['company_street']   = 'Company street'; 
+$labels['company_city']     = 'Company city';
+$labels['company_state']    = 'Company state'; 
+$labels['company_zip']      = 'Company zip'; 
+$labels['company_country']  = 'Company country'; 
+$labels['company_website']  = 'Company website'; 
+$labels['personal_street']  = 'personal street'; 
+$labels['personal_city']    = 'personal city'; 
+$labels['personal_state']   = 'personal state'; 
+$labels['personal_zip']     = 'personal zip'; 
+$labels['personal_country'] = 'personal country'; 
+$labels['personal_website'] = 'Personal website'; 
+$labels['str_birthday']     = 'Birthday'; 
+$labels['str_deathday']     = 'Deathday'; 
+$labels['str_anniversary']  = 'Anniversary'; 
+$labels['email1']           = 'Email 1'; 
+$labels['email2']           = 'Email 2'; 
+$labels['comments']         = 'Comments'; 
+$labels['image']            = 'Image';
+
+$labels['duplicates title'] = 'Duplicate entries';
+$labels['addgroup']     = 'Add group';
+$labels['removegroup']  = 'Remove group';
+$labels['editgroup']    = 'Edit group';
+
 $labels['addcontact'] = 'Add new contact';
 $labels['editcontact'] = 'Edit contact';
 
@@ -173,7 +211,14 @@
 $labels['previouspage']   = 'Show previous set';
 $labels['nextpage']       = 'Show next set';
 
+// vCard
+$labels['uploadvcard']    = 'Import a vCard';
 
+// groupbox names
+$labels['grouplist']  = 'Group';
+$labels['all']  = 'All';
+$labels['last_imported'] = 'Last Imported';
+
 // LDAP search
 $labels['ldapsearch'] = 'LDAP directory search';
 
Index: program/localization/en_US/messages.inc
===================================================================
--- program/localization/en_US/messages.inc	(revision 360)
+++ program/localization/en_US/messages.inc	(working copy)
@@ -108,4 +108,15 @@
 
 $messages['converting'] = 'Removing formatting from message...';
 
+$messages['vcard_instructions'] = 'Choose your vCard to upload<br/ >These will have the file suffix of .vcf';
+
+$messages['duplicate_entries'] = 'We found some entries already in your contact box these following contact shave not been added';
+
+$messages['duplicate_contact'] = 'One or more of your contacts already exists';
+
+$messages['deletecontactgroupconfirm']  = 'Do you really want to remove the selected contact(s) from this group?';
+
+$messages['deletegroupfolderconfirm']  = 'Do you really want to remove the selected group?';
+
+$messages['contactsearchsuccessful'] = '$nr contacts found';
 ?>
Index: program/steps/addressbook/delete.inc
===================================================================
--- program/steps/addressbook/delete.inc	(revision 360)
+++ program/steps/addressbook/delete.inc	(working copy)
@@ -21,79 +21,88 @@
 
 $REMOTE_REQUEST = TRUE;
 
-if ($_GET['_cid'])
-  {
-  $DB->query("UPDATE ".get_table_name('contacts')."
-              SET    del=1
-              WHERE  user_id=?
-              AND    contact_id IN (".$_GET['_cid'].")",
-              $_SESSION['user_id']);
-                     
-  $count = $DB->affected_rows();
-  if (!$count)
-    {
-    // send error message
-    exit;
-    }
+$commands = '';
 
+$mbox = $_GET['_mbox'];
 
-  // count contacts for this user
-  $sql_result = $DB->query("SELECT COUNT(contact_id) AS rows
-                            FROM ".get_table_name('contacts')."
-                            WHERE  del<>1
-                            AND    user_id=?",
-                            $_SESSION['user_id']);
-                                   
-  $sql_arr = $DB->fetch_assoc($sql_result);
-  $rowcount = $sql_arr['rows'];    
+switch($mbox)
+{
+  case 'all':
+      $DB->query("UPDATE ".get_table_name('contacts')."
+                    SET    del=1
+                    WHERE  user_id=?
+                    AND    contact_id IN (".$_GET['_cid'].")",
+                    $_SESSION['user_id']);
+      $sel = "del<>1";  
+      break;
+      
+  case 'last_import':
+      $DB->query("UPDATE ".get_table_name('contacts')."
+                  SET    del=1
+                  WHERE  user_id=?
+                  AND    contact_id IN (".$_GET['_cid'].")",
+                 $_SESSION['user_id']);
+      
+      $sel = "import=1 AND del<>1";      
+      break;
+  
+  default:
+      
+      
+      $sql_result = $DB->query("SELECT contact_ids FROM ".get_table_name('contactgroups')."
+                              WHERE  user_id=?
+                              AND user_groups=?",
+                              $_SESSION['user_id'],
+                              $mbox);
+                                 
+      $sql_arr = $DB->fetch_assoc($sql_result);
 
-  // update message count display
-  $pages = ceil($rowcount/$CONFIG['pagesize']);
-  $commands = sprintf("this.set_rowcount('%s');\n", rcmail_get_rowcount_text($rowcount));
-  $commands .= sprintf("this.set_env('pagecount', %d);\n", $pages);
+      $contact_arr = unserialize($sql_arr['contact_ids']);
+      $del_contact_arr = explode(',',$_GET['_cid']);
+      $n_arr = serialize(array_diff($contact_arr, $del_contact_arr));
+      
+      $commands .= sprintf("alert('%s');\n", "remote reply $tmp2 : $tmp");
+      
+      $DB->query("UPDATE ".get_table_name('contactgroups')."
+                    SET   contact_ids =?
+                    WHERE  user_groups=?
+                    AND user_id=?",
+                    $n_arr,
+                    $mbox,
+                    $_SESSION['user_id']);
+                    
+      // set search in contacts for the page count
+      $sel = "( ";
+      for($i=0; $i<count($contact_arr); $i++){
+        if($contact_arr[$i])
+        $sel .= " contact_id = $contact_arr[$i]";
+        
+        if($contact_arr[$i] && $i != (count($contact_arr)-1))
+          $sel .= " OR";
+      }
+      $sel .= ") AND del<>1";
+                    
+}
 
-
-  // add new rows from next page (if any)
-  if ($_GET['_from']!='show' && $pages>1 && $_SESSION['page'] < $pages)
-    {
-    $start_row = ($_SESSION['page'] * $CONFIG['pagesize']) - $count;
-
-    // get contacts from DB
-    $sql_result = $DB->limitquery("SELECT * FROM ".get_table_name('contacts')."
-                                   WHERE  del<>1
-                                   AND    user_id=?
-                                   ORDER BY name",
-                                   $start_row,
-                                   $count,
-                                   $_SESSION['user_id']);
+      // count contacts for this user
+    $sql_result = $DB->query("SELECT COUNT(contact_id) AS rows
+                              FROM ".get_table_name('contacts')."
+                              WHERE  ".$sel."
+                              AND    user_id=?",
+                              $_SESSION['user_id']);
                                      
-    $commands .= rcmail_js_contacts_list($sql_result);
-
-/*
-    // define list of cols to be displayed
-    $a_show_cols = array('name', 'email');
-    
-    while ($sql_arr = $DB->fetch_assoc($sql_result))
-      {
-      $a_row_cols = array();
-            
-      // format each col
-      foreach ($a_show_cols as $col)
-        {
-        $cont = rep_specialchars_output($sql_arr[$col]);
-        $a_row_cols[$col] = $cont;
-        }
+    $sql_arr = $DB->fetch_assoc($sql_result);
+    $rowcount = $sql_arr['rows'];    
   
-      $commands .= sprintf("this.add_contact_row(%s, %s);\n",
-                           $sql_arr['contact_id'],
-                           array2js($a_row_cols));
-      }
-*/
-    }
+    // update message count display
+    $pages = ceil($rowcount/$CONFIG['pagesize']);
+    $commands = sprintf("this.set_rowcount('%s');\n", rcmail_get_rowcount_text($rowcount));
+    $commands .= sprintf("this.set_env('pagecount', %d);\n", $pages);
+  
+    if(!$errors)
+      $commands .= sprintf("this.remove_contact_row();\n"); 
+      // send response
+      rcube_remote_response($commands);
 
-  // send response
-  rcube_remote_response($commands);
-  }
-
 exit;
-?>
\ No newline at end of file
+?>
Index: program/steps/addressbook/edit.inc
===================================================================
--- program/steps/addressbook/edit.inc	(revision 360)
+++ program/steps/addressbook/edit.inc	(working copy)
@@ -19,7 +19,6 @@
 
 */
 
-
 if (($_GET['_cid'] || $_POST['_cid']) && $_action=='edit')
   {
   $cid = $_POST['_cid'] ? $_POST['_cid'] : $_GET['_cid'];
@@ -64,8 +63,46 @@
 
   // return the complete address edit form as table
   $out = "$form_start<table>\n\n";
-
-  $a_show_cols = array('name', 'firstname', 'surname', 'email');
+  
+  $a_show_cols = array(
+    'name',
+    'email',
+    'firstname',
+    'middlename',
+    'lastname',
+    'maidenname',
+    'prefix',
+    'suffix',
+    'gender',
+    'email1',
+    'email2',
+    'phone_home',
+    'phone_pager',
+    'phone_mobile',
+    'phone_work',
+    'phone_fax',
+    'phone_other',
+    'company_name',
+    'company_title',
+    'company_street',
+    'company_city',
+    'company_state',
+    'company_zip',
+    'company_country',
+    'company_website',
+    'personal_street',
+    'personal_city',
+    'personal_state',
+    'personal_zip',
+    'personal_country',
+    'personal_website',
+    'str_birthday',
+    'str_deathday',
+    'str_anniversary',
+    'comments',
+    'image'
+  );
+  
   foreach ($a_show_cols as $col)
     {
     $attrib['id'] = 'rcmfd_'.$col;
@@ -123,4 +160,4 @@
 
 // this will be executed if no template for addcontact exists
 parse_template('editcontact');
-?>
\ No newline at end of file
+?>
Index: program/steps/addressbook/func.inc
===================================================================
--- program/steps/addressbook/func.inc	(revision 360)
+++ program/steps/addressbook/func.inc	(working copy)
@@ -21,6 +21,9 @@
 
 $CONTACTS_LIST = array();
 
+if (empty($_GET['_mbox'])){
+  $_GET['_mbox'] = "All";
+}
 // set list properties and session vars
 if (strlen($_GET['_page']))
   {
@@ -84,6 +87,8 @@
 
   // set client env
   $javascript = sprintf("%s.gui_object('contactslist', '%s');\n", $JS_OBJECT_NAME, $attrib['id']);
+  $javascript .= sprintf("%s.gui_object('contcontframe', '%s');\n", $JS_OBJECT_NAME, 'addresslist');
+  
   $javascript .= sprintf("%s.set_env('current_page', %d);\n", $JS_OBJECT_NAME, $CONTACTS_LIST['page']);
   $javascript .= sprintf("%s.set_env('pagecount', %d);\n", $JS_OBJECT_NAME, ceil($rowcount/$CONFIG['pagesize']));
   $javascript .= "rcmail.set_env('newcontact', '" . rcube_label('newcontact') . "');";
@@ -98,24 +103,20 @@
   return $out;
   }
 
-
-
 function rcmail_js_contacts_list($sql_result, $obj_name='this')
   {
   global $DB;
-
-  $commands = '';
   
   if (!$sql_result)
     return '';
-
-  // define list of cols to be displayed
+  
+  // define list of cols to be displayed  
   $a_show_cols = array('name', 'email');
-    
+  
   while ($sql_arr = $DB->fetch_assoc($sql_result))
     {
     $a_row_cols = array();
-            
+     
     // format each col
     foreach ($a_show_cols as $col)
       {
@@ -128,11 +129,42 @@
                          $sql_arr['contact_id'],
                          array2js($a_row_cols));
     }
-    
-  return $commands;
-  }
+    return $commands;
+}
 
 
+
+// return code for search function
+
+function rccontacts_search_form($attrib)
+  {
+  global $OUTPUT, $JS_OBJECT_NAME;
+
+  // add some labels to client
+  rcube_add_label('searching');
+
+  $attrib['name'] = '_q';
+  
+  if (empty($attrib['id']))
+    $attrib['id'] = 'rcmqsearchbox';
+  
+  $input_q = new textfield($attrib);
+  $out = $input_q->show();
+
+  $OUTPUT->add_script(sprintf("%s.gui_object('qsearchbox', '%s');",
+                              $JS_OBJECT_NAME,
+                              $attrib['id']));
+
+  // add form tag around text field
+  if (empty($attrib['form']))
+    $out = sprintf('<form name="rcmqsearchform" action="./" '.
+                   'onsubmit="%s.command(\'search\');return false" style="display:inline;">%s</form>',
+                   $JS_OBJECT_NAME,
+                   $out);
+
+  return $out;
+  } 
+  
 // similar function as /steps/settings/identities.inc::rcmail_identity_frame()
 function rcmail_contact_frame($attrib)
   {
@@ -201,4 +233,210 @@
   return $out;
   }
 
+function rcmail_js_groupbox_list($mbox_name, $maxlength, $obj_name='this')
+  {
+  global $DB;
+  
+  static $s_added_script = FALSE;
+  static $a_groupboxes;
+  
+  //if(!$mbox_name)
+  // $mbox_name = "all";
+  
+  $special_groupboxes = array('all','last_imported');
+  $a_groupboxes = array('all', 'last_imported');
+  
+  $sql_result = $DB->query("SELECT user_groups FROM ".get_table_name('contactgroups')."
+                              WHERE  user_id=?
+                              ORDER BY 'user_groups'",
+                               $_SESSION['user_id']);
+  if($sql_result)
+  {
+    $idx = 2;
+    while ($sql_arr = $DB->fetch_assoc($sql_result))
+      {
+        $a_groupboxes[$idx] = $sql_arr['user_groups'];
+        $idx++;
+      } 
+  }
+  $out = rcmail_render_folder_tree_html($a_groupboxes, $special_groupboxes, $mbox_name, $maxlength);
+  return rep_specialchars_output($out, 'url', 'all');
+}
+
+// return the groupboxlist in HTML
+function rcmail_groupbox_list($attrib)
+  {
+  
+  global $CONFIG, $OUTPUT, $JS_OBJECT_NAME, $COMM_PATH, $DB;
+  static $s_added_script = FALSE;
+  static $a_groupboxes;
+  
+  $type = $attrib['type'] ? $attrib['type'] : 'ul';
+  $add_attrib = $type=='select' ? array('style', 'class', 'id', 'name', 'onchange') :
+                                  array('style', 'class', 'id');
+                                  
+  if ($type=='ul' && !$attrib['id'])
+    $attrib['id'] = 'rcmboxlist';
+
+  // allow the following attributes to be added to the <ul> tag
+  $attrib_str = create_attrib_string($attrib, $add_attrib);
+ 
+  $out = '<' . $type . $attrib_str . ">\n";
+  
+  // add no-selection option
+  if ($type=='select' && $attrib['noselection'])
+    $out .= sprintf('<option value="0">%s</option>'."\n",
+                    rcube_label($attrib['noselection']));
+  
+  // get groupbox list
+  if(!$_GET['_mbox'])
+    $mbox_name = "all";
+  else
+    $mbox_name = strtolower($_GET['_mbox']);
+  
+  // for these mailboxes we have localized labels
+  $special_groupboxes = array('all','last_imported');
+  $a_groupboxes = array('all', 'last_imported');
+  
+  
+
+  $sql_result = $DB->query("SELECT user_groups FROM ".get_table_name('contactgroups')."
+                              WHERE  user_id=?
+                              ORDER BY 'user_groups'",
+                               $_SESSION['user_id']);
+  if($sql_result)
+  {
+    $idx = 2;
+    while ($sql_arr = $DB->fetch_assoc($sql_result))
+      {
+        $a_groupboxes[$idx] = $sql_arr['user_groups'];
+        $idx++;
+      } 
+  }
+
+  
+  // build the folders tree
+  if (empty($a_groupboxes))
+    {
+    
+    // get groupbox list
+    //$a_folders = $IMAP->list_groupboxes();
+    
+      $a_folders = array();
+      $a_groupboxes = array('All', 'Last import');
+
+      foreach ($a_folders as $folder)
+        rcmail_build_folder_tree($a_groupboxes, $folder);
+    }
+    
+  //var_dump($a_groupboxes);
+ 
+  if ($type=='select')
+    $out .= rcmail_render_folder_tree_select($a_groupboxes, $special_groupboxes, $mbox_name, $attrib['maxlength']);
+   else
+    $out .= rcmail_render_folder_tree_html($a_groupboxes, $special_groupboxes, $mbox_name, $attrib['maxlength']);
+
+  if ($type=='ul')
+    $OUTPUT->add_script(sprintf("%s.gui_object('groupboxlist', '%s');", $JS_OBJECT_NAME, $attrib['id']));
+  
+  return $out . "</$type>";
+  }
+
+// return html for a structured list <ul> for the mailbox tree
+function rcmail_render_folder_tree_html(&$arrFolders, &$special, &$mbox_name, $maxlength, $nestLevel=0)
+  {
+  global $JS_OBJECT_NAME, $COMM_PATH, $CONFIG, $OUTPUT;
+  
+  $idx = 0;
+  $out = '';
+  foreach ($arrFolders as $key => $folder)
+    {
+    $zebra_class = ($nestLevel*$idx)%2 ? 'even' : 'odd';
+    $title = '';
+    
+    $folder_lc = strtolower($folder);
+    
+    if (in_array($folder_lc, $special))
+      $foldername = rcube_label($folder_lc);
+
+    else
+      {
+      $foldername = $folder;
+      
+      // shorten the folder name to a given length
+      if ($maxlength && $maxlength>3)
+        {
+        $fname = abbrevate_string($foldername, $maxlength);
+        
+        if ($fname != $foldername)
+          $title = ' title="'.rep_specialchars_output($foldername, 'html', 'all').'"';
+          
+          $foldername = $fname;
+        }
+      }
+
+    // make folder name safe for ids and class names
+    $folder_css = $class_name = preg_replace('/[^a-z0-9\-_]/', '', $folder_lc);
+
+    $js_name = htmlspecialchars(rep_specialchars_output($folder, 'js'));
+    $out .= sprintf('<li id="rcmbx%s" class="groupbox %s %s%s"><a href="%s&amp;_mbox=%s"'.
+                    ' onclick="return %s.command(\'list\',\'%s\')"'.
+                    ' onmouseover="return %s.focus_groupbox(\'%s\')"' .            
+                    ' onmouseout="return %s.unfocus_groupbox(\'%s\')"' .
+                    ' onmouseup="return %s.groupbox_mouse_up(\'%s\')"%s>%s</a>',
+                    $folder_css,
+                    $class_name,
+                    $zebra_class,
+                    strtolower($folder) == strtolower($mbox_name) ? ' selected' : '',
+                    $COMM_PATH,
+                    urlencode($folder),
+                    $JS_OBJECT_NAME,
+                    $js_name,
+                    $JS_OBJECT_NAME,
+                    $js_name,
+                    $JS_OBJECT_NAME,
+                    $js_name,
+                    $JS_OBJECT_NAME,
+                    $js_name,
+                    $title,
+                    rep_specialchars_output($foldername, 'html', 'all'));
+
+
+    $out .= "</li>\n";
+    $idx++;
+    }
+
+  return $out;
+  }
+  
+function rcmail_add_group_form($attrib)
+  {
+  global $OUTPUT, $JS_OBJECT_NAME, $SESS_HIDDEN_FIELD;
+
+  // add ID if not given
+  if (!$attrib['id'])
+    $attrib['id'] = 'rcmadd group';
+  
+  // allow the following attributes to be added to the <div> tag
+  $attrib_str = create_attrib_string($attrib, array('id', 'class', 'style'));
+  $label_send = rcube_label('save');
+  $label_close = rcube_label('close');
+  
+  $out = <<<EOF
+<div$attrib_str>
+<form action="./" method="post" enctype="multipart/form-data">
+$SESS_HIDDEN_FIELD
+<input type="text" name="addgroup" value="" id="addgroup" size="16"/>
+<br />
+<input type="button" value="$label_close" class="button" onclick="document.getElementById('$attrib[id]').style.visibility='hidden'" />
+<input type="button" value="$label_send" class="button" onclick="$JS_OBJECT_NAME.addgroupfolder(this.form)" />
+</form>
+</div>
+EOF;
+
+  
+  $OUTPUT->add_script(sprintf("%s.gui_object('addgroupform', '%s');", $JS_OBJECT_NAME, $attrib['id']));  
+  return $out;
+  }
+
 ?>
Index: program/steps/addressbook/group.inc
===================================================================
--- program/steps/addressbook/group.inc	(revision 0)
+++ program/steps/addressbook/group.inc	(revision 0)
@@ -0,0 +1,126 @@
+<?php
+
+/*
+ +-----------------------------------------------------------------------+
+ | program/steps/addressbook/groups.inc                                  |
+ |                                                                       |
+ | This file is part of the RoundCube Webmail client                     |
+ | Copyright (C) 2005, RoundCube Dev. - Switzerland                      |
+ | Licensed under the GNU GPL                                            |
+ |                                                                       |
+ | PURPOSE:                                                              |
+ |   Add grouping refernces to user id and contacts included             |
+ |                                                                       |
+ +-----------------------------------------------------------------------+
+ | Author: Shane Saunders <shane@gnative.com>                            |
+ +-----------------------------------------------------------------------+
+
+ $Id: move_del.inc 269 2006-06-29 23:41:40Z richs $
+
+*/
+$REMOTE_REQUEST = TRUE;
+
+    $commands = '';
+      
+    $folder = $_GET['_folder'] ? $_GET['_folder'] :'';    
+    $cfolder = $_GET['_current_folder'] ? $_GET['_current_folder'] :'';    
+    $do = $_GET['_do'] ? $_GET['_do'] :'';
+    $obj = $_GET['_obj'] ? $_GET['_obj'] :'';
+    
+    switch ($do)
+    {
+    
+      case 'add':
+          // check to the added folder already if one exists
+          $sql_result = $DB->query("SELECT user_groups FROM ".get_table_name('contactgroups')."
+                              WHERE user_id=?",
+                              $_SESSION['user_id']);
+
+          
+          while ($sql_arr = $DB->fetch_assoc($sql_result))
+            if(strtolower($sql_arr['user_groups']) == strtolower($folder))
+              $error = true;
+
+          
+          if(!$error)
+          {
+              $sql = "INSERT INTO contactgroups ( user_id , user_groups) VALUES (".$_SESSION['user_id'].",'".$folder."')";
+              $DB->query($sql) ? $error = false : $error = true;
+              $sel_mbox = $folder;
+              break;
+          }
+          else
+          {
+            // send a message
+            $commands .= sprintf("if(parent.%s)parent.%s.display_message('%s','%s');\n",
+                                             $JS_OBJECT_NAME, 
+                                             $JS_OBJECT_NAME,
+                                             'duplicategroup',
+                                             'error'); 
+            break;
+          }
+        
+          
+      case 'remove':
+          $sql = "DELETE FROM contactgroups WHERE user_id =".$_SESSION['user_id']." AND user_groups = '".$folder."'";
+          $DB->query($sql) ? $error = false : $error = true;
+          break;
+      case 'edit':
+      
+        if(!$cfolder)
+        {
+          $error = true;
+          break;
+        }
+        $sql = "UPDATE contactgroups SET user_groups = ".$folder." WHERE user_id =".$_SESSION['user_id']." AND user_groups = ".$cfolder;
+        $DB->query($sql) ? $error = false : $error = true;
+        $sel_mbox = $folder;
+        break;
+        
+      default:
+        // there was a problem
+      
+    }
+    
+    // tempory addition till i figure out how to get the oringinal value
+    // off the object build from main.php
+    $maxlength = '16'; 
+    
+    if(!$sel_box)
+      $sel_box = 'all';
+      
+    if(!$error)
+    {
+        if($do == 'remove'){
+        $commands .= sprintf("if(parent.%s)parent.%s.altergrouplist('%s','%s');\n",
+                                               $JS_OBJECT_NAME, 
+                                               $JS_OBJECT_NAME,
+                                               'rcmbx'.preg_replace('/[^a-z0-9\-_]/', '', $folder),
+                                               $do); 
+        }
+        else
+        {
+          $commands .= sprintf("if(parent.%s)parent.%s.altergrouplist('%s','%s','%s');\n",
+                                               $JS_OBJECT_NAME, 
+                                               $JS_OBJECT_NAME,
+                                               $folder,
+                                               $do,
+                                               rcmail_js_groupbox_list('', $maxlength)); 
+        
+        }
+    }
+    else
+    {
+      $commands .= sprintf("if(parent.%s)parent.%s.display_message('%s','%s');\n",
+                                             $JS_OBJECT_NAME, 
+                                             $JS_OBJECT_NAME,
+                                             'generalerror',
+                                             'error'); 
+    
+    }
+    // send response
+    rcube_remote_response($commands);
+
+    exit;
+    
+?>
